﻿using IMES_Middleware_Platform.Api.Core.Consts;
using Microsoft.AspNetCore.Builder;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using ZhonTai;
using ZhonTai.Admin.Core;
using ZhonTai.Admin.Core.Configs;
using ZhonTai.Admin.Core.Db;
using ZhonTai.Admin.Core.Startup;
using ZhonTai.ApiUI;
using ZhonTai.Common.Helpers;
using AdminDbkeys = ZhonTai.Admin.Core.Consts.DbKeys;
using AdminSubscribeNames = ZhonTai.Admin.Core.Consts.SubscribeNames;

new HostApp(new HostAppOptions()
{
    //配置前置服务
    ConfigurePreServices = context =>
    {
        var dbConfig = ConfigHelper.Get<DbConfig>("dbconfig", context.Environment.EnvironmentName);
        dbConfig.SyncStructure = false;
        if (dbConfig.Key.NotNull())
        {
            DbKeys.AppDb = dbConfig.Key;
        }
        AdminDbkeys.AppDb = DbKeys.AppDb;
        AdminSubscribeNames.SmsSingleSend = "app.smsSingleSend";
    },
    //配置后置服务
    ConfigurePostServices = context =>
    {
    },
    //配置FreeSql
    ConfigureFreeSql = (freeSql, dbConfig) =>
    {
    },
    //配置Autofac容器
    ConfigureAutofacContainer = (builder, context) =>
    {

    },
    //配置Mvc
    ConfigureMvcBuilder = (builder, context) =>
    {
    },
    //配置后置中间件
    ConfigurePostMiddleware = context =>
    {
        var app = context.App;
        var env = app.Environment;
        var appConfig = app.Services.GetService<AppConfig>();

        #region 新版Api文档
        if (env.IsDevelopment() || appConfig.ApiUI.Enable)
        {
            app.UseApiUI(options =>
            {
                options.RoutePrefix = appConfig.ApiUI.RoutePrefix;
                var routePath = options.RoutePrefix.NotNull() ? $"{options.RoutePrefix}/" : "";
                appConfig.Swagger.Projects?.ForEach(project =>
                {
                    options.SwaggerEndpoint($"/{routePath}swagger/{project.Code.ToLower()}/swagger.json", project.Name);
                });
            });
        }
        #endregion
    }
}).Run(args);

public partial class Program { }