﻿using Microsoft.AspNetCore.Mvc.Testing;
using Microsoft.AspNetCore.TestHost;
using Microsoft.Extensions.DependencyInjection;
using System;
using System.Net.Http;
using ZhonTai.Admin.Core.Configs;
using ZhonTai.Common.Helpers;

namespace IMES_Middleware_Platform.Tests
{
    /// <summary>
    /// 测试基础
    /// </summary>
    public class BaseTest
    {
        protected AppConfig AppConfig { get; }
        protected TestServer Server { get; }
        protected HttpClient Client { get; }
        protected IServiceProvider ServiceProvider { get; }

        protected BaseTest()
        {
            AppConfig = ConfigHelper.Get<AppConfig>("appconfig") ?? new AppConfig();
            var application = new WebApplicationFactory<Program>();
            Client = application.CreateClient();
            Server = application.Server;
            ServiceProvider = Server.Services;
        }

        public T GetService<T>()
        {
            return ServiceProvider.GetService<T>();
        }

        public T GetRequiredService<T>()
        {
            return ServiceProvider.GetRequiredService<T>();
        }
    }
}